// OC调用JS
window.eventDispatcher = function (eventId, resultjson) {
    if (eventId == "imagesDownloadComplete") {
        var value =  JSON.parse(resultjson).key;
        imagesDownloadComplete(value);
    }
    else if (eventId == "setFontName"){
        var value =  JSON.parse(resultjson).key;
        setFontName(value);
    }
    else if (eventId == "setFontSize"){
        var value =  JSON.parse(resultjson).key;
        setFontSize(value);
    }
    else if (eventId == "getAllImage") {
        getAllImage();
    }
};

//更新图片
function imagesDownloadComplete(message) {
    if (message.match("replaceimage")) {
        var index = message.indexOf("~");
        // 截取占位标识
        var messagereplace = message.substring(0, index);
        // 截取到图片路径
        var messagepath = message.substring(index + 1);
        messagereplace = messagereplace.replace(/replaceimage/, "");
        // 获取img
        element = document.getElementById(messagereplace);
        // 保证只替换一次
        if (element.src.match("articleLoading")) {
            element.src = messagepath;
        }
    }
}

// 图片点击事件
function didTappedImage(index, url) {
    alert("Android调用了JS的callJS方法");

    var image = document.getElementById(url);
    var width = image.width;
    var height = image.height;
    var x = image.getBoundingClientRect().left;
    var y = image.getBoundingClientRect().top;
    x = x + document.documentElement.scrollLeft;
    y = y + document.documentElement.scrollTop;
    
    var msgBody = {};
    msgBody.handler = 'WKWeb';
    msgBody.action = 'TapImage';
    msgBody.parameters = {
        'index' : index,
        'x' : x,
        'y' : y,
        'width' : width,
        'height' : height,
        'url' : url
    };

    sendMessage(msgBody);
}

function getAllImage() {
    var imgInfoArray = new Array();
    var imgList = document.getElementById('content').querySelectorAll('img');
    var imgLen = imgList.length;
    for (var i=0; i<imgLen; i++) {
        var image = imgList[i];
        var imageURL = image.getAttribute("id");
        var height = image.height;
        var imgTop = getPos(image).top;
        var imgBottom = getPos(image).bottom;
        
        var imgInfo = {
            'url' : imageURL,
            'h' : height,
            'top' : imgTop,
            'bottom' : imgBottom
        };

        imgInfoArray.push(imgInfo);
    }
    
    return JSON.stringify(imgInfoArray);
}

function getPos(node) {
    var scrollL = document.documentElement.scrollLeft || document.body.scrollLeft,
    scrollT = document.documentElement.scrollTop || document.body.scrollTop,
    pos = node.getBoundingClientRect();
    
    return {
    top: pos.top + scrollT,
    right: pos.right + scrollL,
    bottom: pos.bottom + scrollT,
    left: pos.left + scrollL
    }
}

// 设置字体
function setFontName(name) {
    var content = document.getElementById('content');
    content.style.fontFamily = name;
}

// 设置字体大小
function setFontSize(size) {
    var content = document.getElementById('content');
    content.style.fontSize = size + "px";
}

// 获取网页高度
function getHeight() {
    return document.body.offsetHeight;
}

// Prompt
function sendSyncMessage(params) {
    //将消息体直接JSON字符串化，调用Prompt()
    var resultjson = prompt(JSON.stringify(params));
    //直接用 = 接收 Prompt()的返回数据，JSON反解
    var resultObj = resultjson ? JSON.parse(resultjson) : {};
    
    document.getElementById("returnValue").value = 'PromoteSyncCallback = \n' + JSON.stringify(resultObj);
}

// JaveScript
function sendMessage(data) {
    window.webkit.imageListener.postMessage(data);
}
